<?php
/*
** @name: admin_rack.php
**
** @description: controller for plan rack administration
** @author: Quentin George <q.george@esia-sa.com>
** @date: 06/04/2022
*/

$path = $_SERVER['DOCUMENT_ROOT'];
include_once $path . '/plugin/plan/inc/common_admin_plan.inc.php';
include_once LIB_PLAN_RACK;

define('RACK_LIMITS', array(
	'uSizeMin' => 2,
	'uSizeMax' => 48,
	'zoomMin' => 60,
	'zoomMax' => 200
));
define('RACK_ITEMS_TYPES_NOT_NODE', array("blank", "cable_manag", "patch_panel", "console", "shelf", "power_strip"));

try
{
	if($action == 'admin')
	{
		// Get plan objects devices name & for each rack U the ID of the object linked to it
		$objectsInfo = getRackItemsUlinkAndDeviceName($dbconnection, $plan->getListObjects());
		$smarty->assign('devicesName', $objectsInfo['devicesName']);
		$smarty->assign('uLinksIds', $objectsInfo['uLinksIds']);

		$smarty->assign('RACK_LIMITS', RACK_LIMITS);
		$smarty->assign('RACK_ITEMS_VALID_TYPES', RACK_ITEMS_VALID_TYPES);
		$smarty->assign('RACK_ITEMS_TYPES_NOT_NODE', RACK_ITEMS_TYPES_NOT_NODE);
	}
}
catch(\EsiaDbException | \Plan\PlanException | \Exception $e)
{
	$errors[] = $e->getMessage();
}
$smarty->assign('errors', $errors);

$smarty->display($templatePath . 'admin_rack.html');

?>
