<?php
/*
** @name: control_img.php
**
** @description: controller for plan images
** @author: Quentin George <q.george@esia-sa.com>
** @date: 06/04/2022
*/

$path = $_SERVER['DOCUMENT_ROOT'];
include_once $path . '/plugin/plan/inc/common_control_plan.inc.php';

try
{
	if($action == 'plan' || $action == 'dash_plan')
	{
		// Get objects by types name to have all container & links objects in one array
		$objectsByTypes = $plan->getListObjectsByTypeName(TRUE, $path);
		// For link format source and target ids from old namin to new (old params saved in DB are like obj_type_id.obj_id.'object' new param is only the object id example: 33object become 3)
		$regex = '/\d(\d+)object/';
		foreach($objectsByTypes['link'] as $key => $obj)
		{
			if(!empty($obj['params']['service']))
			{
				$obj['params']['service'] = intval(explode(",", $obj['params']['service'])[0]);
			}
			if(!is_numeric($obj['params']['source']))
			{
				$srcMatches = array();
				preg_match($regex, $obj['params']['source'], $srcMatches);
				if(isset($srcMatches[1]))
				{
					$objectsByTypes['link'][$key]['params']['source'] = $srcMatches[1];
				}
			}
			if(!is_numeric($obj['params']['target']))
			{
				$targMatches = array();
				preg_match($regex, $obj['params']['target'], $targMatches);
				if(isset($targMatches[1]))
				{
					$objectsByTypes['link'][$key]['params']['target'] = $targMatches[1];
				}
			}
		}
		$smarty->assign('objectsByTypes', $objectsByTypes);

		// Only for default plan view not from dashboard
		if($action == 'plan')
		{
			// Get plan view help text
			$smarty->assign('help', '<span class="help-subtitle">' . $lang['PLAN_ICONS'] . '</span>' . $lang['PLAN_HELP_OBJ_DETAILS'] . "\n" . $lang['PLAN_HELP_LINKED_PLAN'] . '<span class="help-subtitle">' . $lang['PLAN_LINKS'] . '</span>' . $lang['PLAN_HELP_LINK_CLICK_GRAPH']);
		}
	}
}
catch(\EsiaDbException | \Plan\PlanException | \Exception $e)
{
	$errors[] = $e->getMessage();
}
$smarty->assign('errors', $errors);

$smarty->display($templatePath . 'control_img.html');

?>
