<?php
/*
** @name: control_rack.php
**
** @description: controller for plan rack
** @author: Quentin George <q.george@esia-sa.com>
** @date: 06/04/2022
*/

$path = $_SERVER['DOCUMENT_ROOT'];
include_once $path . '/plugin/plan/inc/common_control_plan.inc.php';
include_once LIB_PLAN_RACK;

try
{
	if($action == 'plan' || $action == 'dash_plan')
	{
		// Get plan objects devices name & for each rack U the ID of the object linked to it
		$objectsInfo = getRackItemsUlinkAndDeviceName($dbconnection, $plan->getListObjects());
		$smarty->assign('devicesName', $objectsInfo['devicesName']);
		$smarty->assign('uLinksIds', $objectsInfo['uLinksIds']);

		// Only for default plan view not from dashboard
		if($action == 'plan')
		{
			// Get plan view help text
			$smarty->assign('help', $lang['PLAN_HELP_OBJ_DETAILS'] . "\n" . $lang['PLAN_HELP_CLICK_ZOOM']);
		}
	}
}
catch(\EsiaDbException | \Plan\PlanException | \Exception $e)
{
	$errors[] = $e->getMessage();
}
$smarty->assign('errors', $errors);

$smarty->display($templatePath . 'control_rack.html');

?>
