<?php
/*
** @name: common_control_plan.inc.php
**
** @description: code included in all plan types controllers for view mode (control_)
** @author: Quentin George <q.george@esia-sa.com>
** @date: 22/12/2021
*/

$controlType = 'control';
include_once $path . '/plugin/plan/inc/common_plan.inc.php';

// Retrieve saved messages from another page in $_SESSION
if(isset($_SESSION["plan_msg_success"]))
{
	$smarty->assign('success', $_SESSION["plan_msg_success"]);
	unset($_SESSION["plan_msg_success"]);
}

try
{
	if($action == 'plan' || $action == 'dash_plan')
	{
		// Get the plan with its objects and all states
		$plan = Model_plan::instancePlan($dbconnection, $planId, $user->getId(), TRUE, TRUE);

		// Check if page can be displayed
		if($plan->getCurrentUserAccess() == 'NONE')
		{
			$smarty->display('no_access.html');
			exit(0);
		}

		// Assign plan & objects
		$smarty->assign('plan', $plan->toArray());
		$smarty->assign('objects', $plan->getListObjects(TRUE, $path));

		// Only for default plan view not for dashboard
		if($action == 'plan')
		{
			setPlanNavbar($dbconnection, $navbar, $lang['WEBP_PLAN'], $user->getId(), $foldersURL, $plan, $apache_path);
		}
		elseif($action == 'dash_plan')
		{
			$isIframe = TRUE;
			if(isset($_GET['isIframe']) && $_GET['isIframe'] == "false")
			{
				$isIframe = FALSE;
			}
			$smarty->assign('isIframe', $isIframe);
		}
	}
}
catch(\Plan\PlanException $e)
{
	// If there is an issue on plan instanciation the plan does not exist
	$smarty->display('no_access.html');
	exit(0);
}
catch(\EsiaDbException | \Exception $e)
{
	$errors[] = $e->getMessage();
}

?>
