<?php
/*
** @name: common_plan.inc.php
**
** @description: code included in all plan types controllers (control_, admin_, display_, dialog_)
** @author: Quentin George <q.george@esia-sa.com>
** @date: 22/12/2021
*/

include_once $path . '/common.php';
include_once $path . '/Model_adm.php';
include_once $path . '/plugin/plan/plan.conf.php';
include_once MODEL_PLAN;
include_once LIB_PLAN;

// Define usefull variables
$pluginInfos = Model_esia::getWebPlugin($dbconnection, FALSE, 'WEBP_PLAN')[0];
$apache_path = $pluginInfos['apache_path'];
$templatePath = $path . $pluginInfos['apache_path'] . 'templates/';
$foldersURL = $pluginInfos['apache_path'] . 'folder_plan.php';

$isUserPerms = getEsiaPlanPerms($dbconnection, $user);

// Check if user can access to webp_plan in view mode at least. Valid plan id is required to display a plan ...
if(!$isUserPerms['view'] || empty($_GET['id']) || !is_numeric($_GET['id']))
{
	if($controlType == 'dialog')
	{
		$smarty->assign('no_header', true);
	}

	$smarty->display('no_access.html');
	exit(0);
}
else
{
	$planId = intval($_GET['id']);
}

// Action
if(isset($_GET['action']))
{
	$action = $_GET['action'];
}
elseif(isset($_POST['action']))
{
	$action = $_POST['action'];
}
else
{
	$action = 'plan';
}

// Assign template common variables
$smarty->assign('planId', $planId);
$smarty->assign('isUserPerms', $isUserPerms);
$smarty->assign('apache_path', $apache_path);
$smarty->assign('templatePath', $templatePath);
$smarty->assign('action', $action);

$errors = array();

?>
