// Set an object of type container specific actions
function setObjectContainerClickActions(obj)
{
	// Click actions
	obj.on("click", function(e)
	{
		if(e.ctrlKey)
		{
			// Open node state table on ctrl + click
			getObjectsDetails(obj.attr('data-id'), obj.attr('data-name'));
		}
		else
		{
			// Open plan page on simple click
			getObjectPlanLink(obj.attr('data-id'));
		}
	});
}

// Get link service values
function setLinkServiceValues(linkdId, serviceId)
{
	$.ajax({
		type: "GET",
		url: glob_apache_path + "display_img.php?action=getLinkServiceValues",
		data: {id: glob_plan.id, service_id: serviceId},
		dataType: "json"
	}).done(function(data) {
		if (data?.error) { // Error Message
			displayUserMessage(data.error, true);
		}
		else if (data != null) {
			window.planImgApp.addServiceLinkValue(linkdId, data);
			window.planImgApp.repaint();
		}
	});
}

// Set plan img objects by types
function setPlanImgObjects(objectsByTypes)
{
	if(objectsByTypes.container)
	{
		setAllObjectsContainerOnPlan(objectsByTypes.container);
	}
	if(objectsByTypes.link)
	{
		setAllObjectsLinkOnPlan(objectsByTypes.link, false);

		objectsByTypes.link.forEach((obj) => {
			if(obj.params?.service  != '' && !isNaN(obj.params?.service)) {
				setLinkServiceValues(obj.id, parseInt(obj.params.service));
			}
		});
	}
	if(objectsByTypes.service)
	{
		objectsByTypes.service.forEach((obj, i) => {
			setObjectServiceOnPlan(obj);
		});
	}
	if(objectsByTypes.text)
	{
		objectsByTypes.text.forEach((obj, i) => {
			setObjectTextOnPlan(obj);
		});
	}
}

// Initialize event listeners appenning on plan img app
function initPlanImgAppEvents()
{
	$('#plan' + glob_plan.id + " .plan-img-app")[0].addEventListener('nodeUpdated', ({ detail: node }) => {
		var obj = $('#' + node.options.dbid + 'object');

		addTooltipTitle(obj);
		setObjectContainerClickActions(obj);
	});

	document.addEventListener('linkClick', ({ detail }) => {
		if(!isNaN(parseInt(detail.service))) {
			// Open graph dialog on link click
			getServiceGraph(detail.service);
		}
	});
}
