// Handle the node and content selection changes
function onChangeRackItemNodeSelect(obj) {
	// On page load, enable content field if node field is not empty
	if ($("#selectNode").val().length != 0) {
		$(".selectServicesStates").each(function() {
			$(this).prop("disabled", false);
			$(this).trigger("chosen:updated");
		});
	}

	if (obj.params.config == undefined)
	{
		obj.params.config = {};
	}

	// On change
	$("#selectNode").change(function() {
		// Update device_id
		obj.params.config.device_id = $("#selectNode").val();
		// Clean content fields for each item services
		$(".selectServicesStates").each(function() {
			$(this).empty();
			$(this).prop("disabled", false);
		});

		updRackItemSelectServices(obj, $(".selectServicesStates"));
	});

	// Disabled other options in multi select when all services type is selected
	var handleMultiSelectOptsFct = function(select) {
		if (select.val()?.includes("-2")) {
			$("option", select).each(function(key, opt) {
				// Unselect all opts
				$(opt).prop("selected", false);

				if ($(opt).attr("value") == -2) {
					// Reselect the all services opt
					$(opt).prop("selected", true);
				} else if ($(opt).attr("value") > 0) {
					// Disable other services opts
					$(opt).prop("disabled", true);
				}
			});
		} else {
			// Re-enable disbaled options if there is some
			$("option[disabled]", select).each(function(key, opt) {
				$(opt).prop("disabled", false);
			});
		}

		select.trigger("chosen:updated");
	};
	// Init on page load
	$(window).load(function() {
		$(".selectServicesStates[multiple]").each(function() {
			handleMultiSelectOptsFct($(this));
		});
	});
	// On select value change
	$(".selectServicesStates[multiple]").change(function() {
		handleMultiSelectOptsFct($(this));
	});
}

// Handle saving new object configuration parameters
function updObjRackItemEvent(obj, planId) {
	$("#formUpdObjRackItem").submit(function(e) {
		e.preventDefault();

		var formData = getFormValues('formUpdObjRackItem'),
			objParams = {};

		if (!$.isNumeric(obj.id)) {
			objParams = obj.params;
		}

		$.ajax({
			type: "POST",
			url: $(this).attr("action"),
			data: { isJSONResp: true, ...formData, obj_params_old: objParams },
			dataType: "json"
		})
		.done(function(data) {
			if (data.error) {
				// Error Message
				displayUserMessage(data.error, true, 'dialog-messages');
			} else {
				// If new object change it's attributes data on the plan
				if (!$.isNumeric(obj.id)) {
					$("#" + obj.id + "object").remove();
					admSetObjectRackItem(data, data.tmp_params.device_name);
				} else {
					// Update device name
					$("#" + data.id + "object").attr("title", data.tmp_params.device_name || "");
				}
				// Close dialog window
				$("#dialog-info").dialog("close");
			}
		});
	});
}

// Update the service selection options
function updRackItemSelectServices(obj, selectFields) {
	if (obj.params.config.device_id != null) {
		$.ajax({
			type: "GET",
			url: glob_apache_path + "display_rack.php",
			data: {action: "getNodeServices", nodeId: obj.params.config.device_id, itemType: obj.params.common.item_type},
			dataType: "json"
		})
		.done(function(data) {
			if (data.error) {
				// Error Message
				displayUserMessage(data.error, true);
			} else {
				selectFields.each(function(key, field) {
					var stateTag = $(field).attr("data-state");

					// Build each select option
					$(field).append("<option value='-1'></option>");
					if ($(field).attr("multiple")) {
						var langState = "PLAN_RACK_STATE_" + stateTag.toUpperCase();

						$(field).append("<option value='-2'>" + glob_lang.ALL_SERVICES + "-" + glob_lang[langState] + "</option>");
					}
					$.each(data.services, function(k, service) {
						$(field).append("<option value='" + service.id + "'>" + service.name + " [" + service.plugin_name + "]" + "</option>");
					});

					// Auto selection of services by plugin tag
					if (data.autoSelect[stateTag] !== null) {
						$("option[value='" + data.autoSelect[stateTag] + "']", field).prop("selected", true);
					}

					$(field).trigger("change");
					$(field).trigger("chosen:updated");
				});
			}
		});
	}
}

// Action to empty the trash
function emptyTrash() {
	$("#formEmptyTrash").submit(function(e) {
		e.preventDefault();

		var formData = getFormValues('formEmptyTrash'),
			deleteObj = getTrashObjWithDbId();

		if(deleteObj.length > 0) {
			// Remove DB saved objects
			$.ajax({
				type: "POST",
				url: $(this).attr("action"),
				data: { isJSONResp: true, ...formData, delete_objects: deleteObj },
				dataType: "json"
			})
			.done(function(data) {
				if(data.error) {
					// Error Message
					displayUserMessage(data.error, true, 'dialog-messages');
				} else {
					// Remove all remaining trash content
					$(".trash-content").empty();
					handleIsTrashDisabled();
					$("#dialog-info").dialog("close");
				}
			});
		}
		else {
			$(".trash-content").empty();
			handleIsTrashDisabled();
			$("#dialog-info").dialog("close");
		}
	});
}

// Init plan rack item object configuration
function initRackItemObjConf(obj, planId) {
	onChangeRackItemNodeSelect(obj);
	updObjRackItemEvent(obj, planId);
}
