// Set all objects of type container on the plan
function setAllObjectsContainerOnPlan(objects)
{
	var objectsAppParams = [];

	objects.forEach((obj) => {
		objectsAppParams.push({
			id: obj.id,
			name: obj.name,
			position: obj.params.position,
			size: obj.params.size,
			icon: {
				id: obj.icon_id,
				path: obj.icon_file.path,
				isUniq: obj.icon_file.isUniq,
				isInDefaultState: obj.icon_file.isInDefaultState,
			},
			state: obj.state_code
		});
	});

	window.planImgApp.addContainerNodes(objectsAppParams);
}

// Set all objects links on the plan
function setAllObjectsLinkOnPlan(objects)
{
	var objectsAppParams = [];

	objects.forEach((obj) => {
		objectsAppParams.push({
			id: obj.id,
			service: obj.params?.service || '',
			source: obj.params.source,
			target: obj.params.target,
			points: obj.params?.points || [],
			state: obj.state_code,
			stateColor: PLAN_SERVICE_STATE_COLORS[obj.state_code] || PLAN_SERVICE_STATE_COLORS[3],
			isDisableArrows: obj.params?.isDisableArrows || false,
			isDisableLabels: obj.params?.isDisableLabels || false
		});
	});

	window.planImgApp.addServiceLinks(objectsAppParams);
}
