// Set the object rack item icon svg
function setObjRackItemSVG(container) {
	var originalSvgSelector = "#svg_rack_elt_" + container.attr("data-item-type"),
		subType = container.attr("data-item-subtype");

	if (subType !== undefined && subType !== "none") {
		originalSvgSelector += "_" + subType + "_" + container.attr("data-u-size") + "u";
	} else {
		originalSvgSelector += "_" + container.attr("data-u-size") + "u";
	}

	container.append($(originalSvgSelector).clone());
}

// Set the object rack on u
function setRackItemOnU(container, uPos, uSize, posGap=0) {
	var rackU = $('.rack-u-' + uPos),
		rackUHeight = rackU[0].getBoundingClientRect().height; // Get floating point value for more precision

	container.css({
		top: (rackU.position().top - posGap) + "px",
		height: (rackUHeight * uSize) + "px",
	});
}

// Common tasks used to create obj rack item on the rack (admin and view mode)
function setObjectRackItemCommon(obj, containerClasses="planObjView", deviceName='') {
	var plan = $("#plan" + glob_plan.id),
		container = $("<div>", {
			"id": obj.id + "object",
			"class": "objRackItem " + containerClasses,
			"data-id": obj.id,
			"data-type": obj.type_name,
			"data-item-type": obj.params.common.item_type,
			"data-item-subtype": obj.params.common.item_subtype,
			"data-u": obj.params.common.u_position,
			"data-u-size": obj.params.common.u_size,
			"title": deviceName,
		});

	setObjRackItemSVG(container);
	setRackItemOnU(container, obj.params.common.u_position, obj.params.common.u_size);

	$(".rack-objects", plan).append(container);

	addTooltipTitle(container);
}

// Add separators when some U are hidden
function setRackEmtyUSeparators() {
	// Reset all reduced U separators
	$(".rack-u-parts .reducedU").remove();

	// Set new reduced U separators
	if ($(".empty-u-hidden").length > 0) {
		// Get all U sorted by descending U number
		var racksU = $(".empty-u-hidden .rack-u").sort(function(a, b) {
				return parseInt($(b).attr("data-u")) - parseInt($(a).attr("data-u"));
			}),
			reducedUTopIndex = 0;

		// Add separator after each empty U followed by a not empty U or if the last U (U1) is empty
		for (var i = 0; i < racksU.length; i++) {
			if ($(racksU[i]).attr("data-link-id") == 0 && (i == 0 || $(racksU[i - 1]).attr("data-link-id") != 0)) {
				$("<div>", {"class": "reducedU reducedU-top"}).insertBefore($(racksU[i]));
				reducedUTopIndex = i;
			}
			if ($(racksU[i]).attr("data-link-id") == 0 && (i == racksU.length - 1 || $(racksU[i + 1]).attr("data-link-id") != 0)) {
				$("<div>", {"class": "reducedU reducedU-bottom"}).insertAfter($(racksU[i]));
				$("<div>", {"class": "reducedUNbr", "data-reduced-nbr": (i + 1) - reducedUTopIndex}).insertBefore($(racksU[i]));

			}
		}
	}
}

// Get the ids of the object in the trash with valid db id (not tmp object which are not saved yet)
function getTrashObjWithDbId() {
	var deleteObj = [],
		regex = new RegExp("^\\d+$");

	$(".trashObj").each(function() {
		var objId = $(this).attr("data-id");
		// If object ID is an integer it's a object saved in DB (if the object is not saved yet its ID begin by tmp-)
		if(regex.test(objId)) {
			deleteObj.push(objId);
		}
	});

	return deleteObj;
}

// Check if trash contain object or not and disable it if empty
function handleIsTrashDisabled() {
	var trashContentLength = $(".trash .objRackItem").length;

	$(".trash span").attr("data-nbr", trashContentLength);

	if (trashContentLength > 0) {
		$(".trash").removeClass("isDisabled");
	} else {
		$(".trash").addClass("isDisabled");
	}
}
