<?php
/*
** @name: plan.conf.php
**
** @description: configuration file used to defined specific constantes and libraries path
** @author: Quentin George <q.george@esia-sa.com>
** @date: 25/07/2022
*/

// Esia libs
define('WEB_ROOT', $_SERVER['DOCUMENT_ROOT']);
define('LIB_ESIA_CONVERT', WEB_ROOT . '/libs/convert.lib.php');

// Plan classes & libraries
define('WEBP_PLAN_ROOT', WEB_ROOT . '/plugin/plan/');
define('MODEL_PLAN', WEBP_PLAN_ROOT . 'Model_plan.php');
define('ABSTRACT_PLAN_CLASS', WEBP_PLAN_ROOT . 'libs/AbstractPlan.class.php');
define('PLAN_CLASS', WEBP_PLAN_ROOT . 'libs/Plan.class.php');
define('OBJECT_PLAN_CLASS', WEBP_PLAN_ROOT . 'libs/ObjectPlan.class.php');
define('LIB_PLAN', WEBP_PLAN_ROOT . 'libs/plan.lib.php');
define('LIB_PLAN_IMG', WEBP_PLAN_ROOT . 'libs/plan_img.lib.php');
define('LIB_PLAN_RACK', WEBP_PLAN_ROOT . 'libs/plan_rack.lib.php');

// Constants
define('ALERTS_STATES', array('ok' => 0, 'warning' => 1, 'critical' => 2, 'unknown' => 3));
define('ALERTS_STATES_STR', array('ok', 'warning', 'critical', 'unknown'));
define('ALERTS_PRIORITIES', array(
		ALERTS_STATES['critical'],
		ALERTS_STATES['warning'],
		ALERTS_STATES['unknown'],
		ALERTS_STATES['ok']
));
define('NAME_FORBIDDEN_CHARS', array(' ', '.', '"'));
define('NAME_REPLACEMENT_CHAR', '_');
define('DEFAULT_ADM_STATES', 'ok');
define('DATA_PLANS', '/data/plan/plans/');
define('DATA_ICONS', '/data/plan/icons/');

?>
