CREATE OR REPLACE FUNCTION getallchildplanfolder(IN folderid integer[])
  RETURNS TABLE(fold_id integer, fold_name character varying, fold_parent_id integer) AS
$BODY$
    BEGIN
	IF folderid IS NULL
	THEN
	RETURN QUERY SELECT folder_id,folder_name,folder_parent_id
		     FROM plan_folders AS f;
	ELSE
		RETURN QUERY
			WITH RECURSIVE q AS (SELECT folder_id,folder_name,folder_parent_id
				FROM plan_folders
				WHERE folder_id = ANY (folderid)
				UNION ALL
				SELECT m.folder_id, m.folder_name,m.folder_parent_id
				FROM plan_folders m
				JOIN q ON m.folder_parent_id = q.folder_id)
			SELECT * FROM q;
	END IF;
   END;
$BODY$
  LANGUAGE plpgsql VOLATILE
  COST 100
  ROWS 1000;
ALTER FUNCTION getallchildplanfolder(integer)
  OWNER TO esia;
