-- 3.3 new default read user group
INSERT INTO public.esia_privilege_grantedto(grant_group_id, grant_privilege_id, grant_acces)
VALUES ((SELECT group_id FROM esia_groups WHERE group_name= 'default_read_access' ), (SELECT privilege_id FROM esia_privileges WHERE privilege_name='map_view'), 1);

-- Outil service
INSERT INTO plan_object_types(type_name) VALUES ('service');

-- Fonction qui recupere le droit le plus prioritaire d'un plan pour un utilisateur. CREATOR, WRITE, READ
CREATE OR REPLACE FUNCTION getPlanUserAccess(IN idplan integer,IN iduser integer)
	RETURNS character varying
	LANGUAGE 'plpgsql'
	COST 100
	VOLATILE
AS $BODY$
DECLARE
	v_row record;
	v_access character varying;
BEGIN
	FOR v_row IN SELECT plan_access_privileges
				FROM plan_users_access
				WHERE plan_access_user_id=iduser AND plan_access_plan_id=idplan
	LOOP
		IF v_row.plan_access_privileges = 'CREATOR'
		THEN
			RETURN v_row.plan_access_privileges;
		ELSIF v_row.plan_access_privileges = 'WRITE' AND (v_access IS NULL OR v_access='READ')
		THEN
			v_access:=v_row.plan_access_privileges;
		ELSE
			v_access:=v_row.plan_access_privileges;
		END IF;
	END LOOP;
	RETURN v_access;
END;
$BODY$;

ALTER FUNCTION public.getPlanUserAccess(IN idplan integer,IN iduser integer) OWNER TO esia;
-- USAGE: SELECT * FROM getPlanUserAccess(:plan_id, :user_id);

-- Create new colmn type_default_params
ALTER TABLE plan_types ADD COLUMN type_default_params json;
-- Update plans
UPDATE esia_web_plugin SET web_php_menu='menu_plan.php', web_index_page='folder_plan.php' WHERE web_name='WEBP_PLAN';
UPDATE plan_types SET type_controller='control_img.php?action=plan', type_default_params='{"url": "", "refresh": 0, "ressources": "off"}' WHERE type_name='image';
-- Plan Rack
INSERT INTO plan_types(type_name, type_controller, type_default_params) VALUES ('rack', 'control_rack.php?action=plan', '{"refresh": 0, "ressources": "off", "rack": {"u_size": "42", "zoom": "100", "empty_u_hidden": ""}}');
INSERT INTO plan_object_types(type_name, type_controller, type_default_params) VALUES ('rack_item', NULL, NULL);

-- New plan img icons
UPDATE plan_object_icons SET icon_type='svg' WHERE icon_name='localisation';
UPDATE plan_object_icons SET icon_type='svg' WHERE icon_name='cloud';
UPDATE plan_object_icons SET icon_type='svg' WHERE icon_name='esia';
UPDATE plan_object_icons SET icon_type='svg' WHERE icon_name='legend_wm';
INSERT INTO plan_object_icons(icon_name, icon_path, icon_type, icon_group_id) VALUES ('access_point', '/data/plan/icons/', 'svg', 1);
INSERT INTO plan_object_icons(icon_name, icon_path, icon_type, icon_group_id) VALUES ('camera', '/data/plan/icons/', 'svg', 1);
